org.optaplanner.core.api.score.buildin.simple

## Class SimpleScore

- java.lang.Object
- - org.optaplanner.core.api.score.AbstractScore<SimpleScore>
  - - org.optaplanner.core.api.score.buildin.simple.SimpleScore

- All Implemented Interfaces:
    Serializable, Comparable<SimpleScore>, Score<SimpleScore>

      public final class SimpleScore
      extends AbstractScore<SimpleScore>

  This `Score` is based on 1 level of int constraints.

  This class is immutable.

  See Also:
    `Score`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static SimpleScore` | `ONE`
    `static SimpleScore` | `ZERO`

    - ### Fields inherited from class org.optaplanner.core.api.score.AbstractScore

      `INIT_LABEL, initScore`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `SimpleScore` | `add(SimpleScore addend)` Returns a Score whose value is (this + addend).
    `int` | `compareTo(SimpleScore other)`
    `SimpleScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
    `boolean` | `equals(Object o)`
    `int` | `getScore()` The total of the broken negative constraints and fulfilled positive constraints.
    `int` | `hashCode()`
    `boolean` | `isCompatibleArithmeticArgument(Score otherScore)`
    `boolean` | `isFeasible()` A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true.
    `SimpleScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
    `SimpleScore` | `negate()` Returns a Score whose value is (- this).
    `static SimpleScore` | `of(int score)`
    `static SimpleScore` | `ofUninitialized(int initScore, int score)`
    `static SimpleScore` | `parseScore(String scoreString)`
    `SimpleScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
    `SimpleScore` | `subtract(SimpleScore subtrahend)` Returns a Score whose value is (this - subtrahend).
    `Number[]` | `toLevelNumbers()` Returns an array of numbers representing the Score.
    `String` | `toShortString()` Like `Object.toString()`, but trims score levels which have a zero weight.
    `String` | `toString()`
    `static SimpleScore` | `valueOf(int score)` Deprecated. in favor of `of(int)`
    `static SimpleScore` | `valueOfUninitialized(int initScore, int score)` Deprecated. in favor of `ofUninitialized(int, int)`
    `SimpleScore` | `withInitScore(int newInitScore)` For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.

    - ### Methods inherited from class org.optaplanner.core.api.score.AbstractScore

      `assertNoInitScore, buildScorePattern, buildShortString, getInitPrefix, getInitScore, isSolutionInitialized, parseInitScore, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseScoreTokens`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.Score

      `toInitializedScore`

- - ### Field Detail

    - #### ZERO

          public static final SimpleScore ZERO

    - #### ONE

          public static final SimpleScore ONE

  - ### Method Detail

    - #### parseScore

          public static SimpleScore parseScore(String scoreString)

    - #### ofUninitialized

          public static SimpleScore ofUninitialized(int initScore,
                                                    int score)

    - #### valueOfUninitialized

          @Deprecated
          public static SimpleScore valueOfUninitialized(int initScore,
                                                                     int score)

      Deprecated. in favor of `ofUninitialized(int, int)`

    - #### of

          public static SimpleScore of(int score)

    - #### valueOf

          @Deprecated
          public static SimpleScore valueOf(int score)

      Deprecated. in favor of `of(int)`

    - #### getScore

          public int getScore()

      The total of the broken negative constraints and fulfilled positive constraints. Their weight is included in the total. The score is usually a negative number because most use cases only have negative constraints.
      Returns:
        higher is better, usually negative, 0 if no constraints are broken/fulfilled

    - #### withInitScore

          public SimpleScore withInitScore(int newInitScore)

      Description copied from interface: `Score`
      For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.
      Parameters:
        `newInitScore` - always negative (except in statistical calculations), 0 if all planning variables are initialized
      Returns:
        equals score except that `Score.getInitScore()` is set to `newInitScore`

    - #### add

          public SimpleScore add(SimpleScore addend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this + addend).
      Parameters:
        `addend` - value to be added to this Score
      Returns:
        this + addend

    - #### subtract

          public SimpleScore subtract(SimpleScore subtrahend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this - subtrahend).
      Parameters:
        `subtrahend` - value to be subtracted from this Score
      Returns:
        this - subtrahend, rounded as necessary

    - #### multiply

          public SimpleScore multiply(double multiplicand)

      Description copied from interface: `Score`
      Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

      Parameters:
        `multiplicand` - value to be multiplied by this Score.
      Returns:
        this * multiplicand

    - #### divide

          public SimpleScore divide(double divisor)

      Description copied from interface: `Score`
      Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

      Parameters:
        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor

    - #### power

          public SimpleScore power(double exponent)

      Description copied from interface: `Score`
      Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

      Parameters:
        `exponent` - value by which this Score is to be powered
      Returns:
        this ^ exponent

    - #### negate

          public SimpleScore negate()

      Description copied from interface: `Score`
      Returns a Score whose value is (- this).
      Returns:
        - this

    - #### isFeasible

          public boolean isFeasible()

      Description copied from interface: `Score`
      A `PlanningSolution` is feasible if it has no broken hard constraints and `Score.isSolutionInitialized()` is true. Simple scores (`SimpleScore`, `SimpleLongScore`, `SimpleBigDecimalScore`) are always feasible, if their `Score.getInitScore()` is 0.
      Returns:
        true if the hard score is 0 or higher and the `Score.getInitScore()` is 0.

    - #### toLevelNumbers

          public Number[] toLevelNumbers()

      Description copied from interface: `Score`
      Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

      When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`). The length of the returned array must be stable for a specific `Score` implementation.

      For example: `-0hard/-7soft` returns `new int{-0, -7}`

      The level numbers do not contain the `Score.getInitScore()`. For example: `-3init/-0hard/-7soft` also returns `new int{-0, -7}`

      Returns:
        never null
      See Also:
        `ScoreDefinition.fromLevelNumbers(int, Number[])`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### compareTo

          public int compareTo(SimpleScore other)

    - #### toShortString

          public String toShortString()

      Description copied from interface: `Score`
      Like `Object.toString()`, but trims score levels which have a zero weight. For example 0hard/-258soft returns -258soft.

      Do not use this format to persist information as text, use `Object.toString()` instead, so it can be parsed reliably.

      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### isCompatibleArithmeticArgument

          public boolean isCompatibleArithmeticArgument(Score otherScore)

      Parameters:
        `otherScore` - never null
      Returns:
        true if the otherScore is accepted as a parameter of `Score.add(Score)`, `Score.subtract(Score)` and `Comparable.compareTo(Object)`.

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.